using System;
using System.Collections.Generic;
using System.IO;
using System.Reflection;
using Weland;
using Gtk;
using System.Drawing;

namespace AlterMonsterFlags
{
	public class Plugin
	{

		public static bool Compatible()
		{
			return true;
		}

		public static string Name()
		{
			return "Alter Monster Falgs";
		}

		public static void GtkRun(Editor editor)
		{
			new AlterMonsterFlags(editor);
		}
	}

	class AlterMonsterFlags : Window
	{

		Editor _editor;
		CheckButton chkFromCeilingApply;
		CheckButton chkFromCeiling;
		CheckButton chkTeleportsInApply;
		CheckButton chkTeleportsIn;
		CheckButton chkTeleportsOutApply;
		CheckButton chkTeleportsOut;
		CheckButton chkIsBlindApply;
		CheckButton chkIsBlind;
		CheckButton chkIsDeafApply;
		CheckButton chkIsDeaf;

		public AlterMonsterFlags(Editor editor) : base("Monster Falgs")
		{
			_editor = editor;

			// Horrible GTK code
			SetDefaultSize(180, 100);
			SetPosition(WindowPosition.Center);
			this.BorderWidth = 0;

			VBox box1 = new VBox(false, 0);

			// Label sep1 = new Label();
			// sep1.Text = "-------------";
			// box1.PackStart(sep1, true, true, 0);
			// sep1.Show();

			Label lblFromCeiling = new Label();
			lblFromCeiling.Markup = "<b>From Ceiling</b>";
			box1.PackStart(lblFromCeiling, true, true, 0);
			lblFromCeiling.Show();

			chkFromCeilingApply = new CheckButton("Apply");
			box1.PackStart(chkFromCeilingApply, true, true, 0);
			chkFromCeilingApply.Show();

			chkFromCeiling = new CheckButton("From Ceiling");
			box1.PackStart(chkFromCeiling, true, true, 0);
			chkFromCeiling.Show();

			// Label sep2 = new Label();
			// sep2.Text = "-------------";
			// box1.PackStart(sep2, true, true, 0);
			// sep2.Show();

			Label lblTeleportsIn = new Label();
			lblTeleportsIn.Markup = "<b>Teleports In</b>";
			box1.PackStart(lblTeleportsIn, true, true, 0);
			lblTeleportsIn.Show();

			chkTeleportsInApply = new CheckButton("Apply");
			box1.PackStart(chkTeleportsInApply, true, true, 0);
			chkTeleportsInApply.Show();

			chkTeleportsIn = new CheckButton("Teleports In");
			box1.PackStart(chkTeleportsIn, true, true, 0);
			chkTeleportsIn.Show();

			// Label sep3 = new Label();
			// sep3.Text = "-------------";
			// box1.PackStart(sep3, true, true, 0);
			// sep3.Show();

			Label lblTeleportsOut = new Label();
			lblTeleportsOut.Markup = "<b>Teleports Out</b>";
			box1.PackStart(lblTeleportsOut, true, true, 0);
			lblTeleportsOut.Show();

			chkTeleportsOutApply = new CheckButton("Apply");
			box1.PackStart(chkTeleportsOutApply, true, true, 0);
			chkTeleportsOutApply.Show();

			chkTeleportsOut = new CheckButton("Teleports Out");
			box1.PackStart(chkTeleportsOut, true, true, 0);
			chkTeleportsOut.Show();

			// Label sep4 = new Label();
			// sep4.Text = "-------------";
			// box1.PackStart(sep4, true, true, 0);
			// sep4.Show();

			Label lblIsBlind = new Label();
			lblIsBlind.Markup = "<b>Is Blind</b>";
			box1.PackStart(lblIsBlind, true, true, 0);
			lblIsBlind.Show();

			chkIsBlindApply = new CheckButton("Apply");
			box1.PackStart(chkIsBlindApply, true, true, 0);
			chkIsBlindApply.Show();

			chkIsBlind = new CheckButton("Is Blind");
			box1.PackStart(chkIsBlind, true, true, 0);
			chkIsBlind.Show();

			// Label sep5 = new Label();
			// sep5.Text = "-------------";
			// box1.PackStart(sep5, true, true, 0);
			// sep5.Show();

			Label lblIsDeaf = new Label();
			lblIsDeaf.Markup = "<b>Is Deaf</b>";
			box1.PackStart(lblIsDeaf, true, true, 0);
			lblIsDeaf.Show();

			chkIsDeafApply = new CheckButton("Apply");
			box1.PackStart(chkIsDeafApply, true, true, 0);
			chkIsDeafApply.Show();

			chkIsDeaf = new CheckButton("Is Deaf");
			box1.PackStart(chkIsDeaf, true, true, 0);
			chkIsDeaf.Show();

			Button button = new Button("Apply Flags");
			button.Clicked += apply_flags;
			box1.PackStart(button, true, true, 0);
			button.Show();

			this.Add(box1);
			box1.Show();

			this.ShowAll();
		}

		void apply_flags(object obj, EventArgs args)
		{
			try
			{
				_editor.SetUndo();

				foreach (var o in _editor.Level.Objects)
				{
					if (o.Type == ObjectType.Monster)
					{
						if(chkFromCeilingApply.Active)
							o.FromCeiling = chkFromCeiling.Active;

						if(chkTeleportsInApply.Active)
							o.Invisible = chkTeleportsIn.Active;

						if(chkTeleportsOutApply.Active)
							o.Floats = chkTeleportsOut.Active;

						if(chkIsBlindApply.Active)
							o.Blind = chkIsBlind.Active;

						if(chkIsDeafApply.Active)
							o.Deaf = chkIsDeaf.Active;
					}
				}

				this.Destroy();
			}
			catch
			{ // Having a prahblum?
				MessageDialog md = new MessageDialog(null, DialogFlags.Modal, MessageType.Info, ButtonsType.Ok,
									   "Prahblum detected!");
				md.Run();
				md.Destroy();
				_editor.Undo();
			}
		}
	}
}