﻿using System;
using System.Collections.Generic;

namespace GeneratorCommon
{
	public static class Extensions
	{
		public static void Shuffle<T>(this IList<T> list)
		{
			var random = new Random();
			int n = list.Count;
			while (n > 1)
			{
				n--;
				var k = random.Next(n + 1);
				T value = list[k];
				list[k] = list[n];
				list[n] = value;
			}
		}

		public static List<short> Clone(this List<short> listToClone)
		{
			var newList = new List<short>();
			foreach (var item in listToClone)
			{
				newList.Add(item);
			}
			return newList;
		}

		public static List<T> Clone<T>(this List<T> listToClone)
		{
			var newList = new List<T>();
			foreach (var item in listToClone)
			{
				newList.Add(item);
			}
			return newList;
		}
	}
}
